

#include <TM1637Display.h> //timer display library
#include <Servo.h> //servo library

//time supplied in ms
#define numberofSeconds(_time_)((_time_/1000)%60) //function that will get fractional seconds parts of time
#define numberofMinutes(_time_)(((_time_/1000)/60)%60) //factional minute parts of a time

#define buttonPin 3 //study connected to pin 3 
#define restButton 2 //rest time button connected to pin 2

byte buttonState; //defining buttonState variable for study button to determine HIGH or LOW
byte buttonState2; //buttonState varaible for rest button

#define limitSwitch 9 //limitSwitch connected to pin 2

Servo servo1; //servo opening lid
Servo servo2;//servo releasing latch

TM1637Display display (13,12); //timer display. parameters are (clock pin, data pin);


int timeLimit=15000; //amount of time studying
int timeLimit2=5000; //break time


void setup() {
  Serial.begin(9600); //beginning serial communication
  display.setBrightness(5);//set brightness on display
  display.clear(); //clear display



  
  pinMode(buttonPin,INPUT_PULLUP); //initializing button as input with internal pull up resistor to monitor state of button
  pinMode(limitSwitch,INPUT_PULLUP); //initializing switch as input with internal pull up resistor
  pinMode(restButton,INPUT_PULLUP);

  servo1.attach(4); //servo 1 attached to pin 6
  servo1.write (90); //beginning with closed lid

  servo2.attach(10); //servo 2 attached to pin 3
  servo2.write(15); //beginning with latch locked in
}

void countdown() {//study countdown
  int startTime=0;
  Serial.println(millis());
  extern volatile unsigned long timer0_millis; //variable for resetting millis()
  
  noInterrupts();
  timer0_millis=0;
  interrupts();
  
  unsigned long timeRemaining=millis()-startTime;
  
  while (timeRemaining<=timeLimit){
    //separating into parts to display countdown in mm:ss format
    int seconds=numberofSeconds(timeRemaining); 
    Serial.println("seconds:");
    Serial.print(seconds);
    int minutes=numberofMinutes(timeRemaining);
    display.showNumberDecEx(seconds,0,true,2,2); //display seconds in the last 2 places
    display.showNumberDecEx(minutes,0b01000000,true,2,0); //displays minutes in first 2 places with a colon
    timeRemaining=millis()-startTime; //updating time remaining 
    Serial.println("The time remaining is:");
    Serial.print(timeRemaining);
    Serial.println("the time limit is:");
    Serial.print(timeLimit);
    }
      
      if(timeRemaining>timeLimit){
        display.showNumberDecEx(0,0b01000000,true,4,2);//display 00:00
        Serial.println("the timeRemaining is:");
        Serial.println(timeRemaining);
        Serial.println("the time limit is:");
        Serial.print(timeLimit);
        servo1.write(0); //opens lid
        delay(1000);
        servo2.write(140); //releases latch 
       }
}

void countdown2() { //break time countdown
  int startTime=0;
  Serial.println(startTime);
  extern volatile unsigned long timer0_millis;
  
  noInterrupts();
  timer0_millis=0;
  interrupts();
 
  unsigned long timeRemaining=millis()-startTime;
  
  while (timeRemaining<=timeLimit2){
    int seconds=numberofSeconds(timeRemaining);
    int minutes=numberofMinutes(timeRemaining);
    display.showNumberDecEx(seconds,0,true,2,2); //display seconds in the last 2 places
    display.showNumberDecEx(minutes,0b01000000,true,2,0); //displays minutes in first 2 places with a colon
    timeRemaining=millis()-startTime; //updating time remaining 
    Serial.println("The time remaining is:");
    Serial.print(timeRemaining);
    }
    
    if(timeRemaining>timeLimit2){
      display.showNumberDecEx(0,0b01000000,true,4,2);

      Serial.println("the timeRemaining is:");
      Serial.println(timeRemaining);
      Serial.println("the time limit is:");
      Serial.print(timeLimit);
      Serial.println(timeLimit2);
      servo1.write(0);
      delay(1000);
      servo2.write(140);
       }
  
}

      
 void loop(){
  buttonState=digitalRead(buttonPin); //reads state of study button 
  if(buttonState==LOW){ //study button is pressed
    countdown(); //begin study countdown 
  }

  buttonState2=digitalRead(restButton);//reads state of break button
  if(buttonState2==LOW){ //break button is pressed
    countdown2(); //begin break
  }
 
int state=digitalRead(limitSwitch); //reads state of switch
  if(state==LOW){ //switch is pressed
          Serial.println("The limit switch has been touched");
          servo2.write(15);//latch secured
          delay(3000);
          servo1.write(90); //lid closes
          
        }

}

 
 

  
